function varargout=plot(self,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  %p.PartialMatching=false;
  p.addParamValue('d',self.d,@isscalar);
  p.addParamValue('labels',[]); % select labels to draw
  p.addParamValue('labName',[]); % function for string legend label name
  p.addParamValue('legend',false,@islogical);
  p.addParamValue('mouse',true,@islogical);
  p.addParamValue('bounds',false,@islogical);
  p.addParamValue('color',[]); % default colors
  p.parse(varargin{:});
  R=p.Results;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  if fc_tools.comp.isOctave()
    NotImplemented={'FaceAlpha','EdgeAlpha'};
    nv=length(varargin);
    varargin=fc_tools.utils.deleteCellOptions(varargin,NotImplemented);
    if length(varargin)<nv
      fprintf('[fc-simesh] ''FaceAlpha'' or ''EdgeAlpha'' not yet implemented in plot\n');
    end
  end
  if isempty(R.labels), idxlab=self.find(R.d);else idxlab=self.find(R.d,R.labels);end
  if isempty(idxlab)
    if nargout>=1, varargout{1}=[];end
    if nargout==2, varargout{2}={};end
    return;
  end
  
  if isempty(R.labName), labName=funLabName(self,R.d); else labName=R.labName;end
  ColorOption={};
  if ~isempty(R.color), ColorOption={'color',fc_tools.graphics.colorstr2rgb(R.color)};R.legend=false;end
  PrevHold=fc_tools.graphics.SetHoldOn(true);
  h=zeros(length(idxlab),1);j=1;
  clegend=cell(length(idxlab),1);
  for ilab=[idxlab]
    if R.bounds 
      if (self.sTh{ilab}.d==2)
        Th=self.sTh{ilab}.getBoundMesh();
        h(j)=Th.plot(ColorOption{:},varargin{:});
        clegend{j}=labName(self.sTh{ilab}.label);
        j=j+1;
      end
    else
      h(j)=self.sTh{ilab}.plot(ColorOption{:},varargin{:});
      clegend{j}=labName(self.sTh{ilab}.label);
      j=j+1;
    end
  end
  if self.dim==3,  view(3);end
  if ((R.legend) && (j>1)), legend(h,clegend,'Location','NorthEastOutside');end
  if (R.mouse) && (~fc_tools.comp.isOctave())
    datacursormode on
    dcm = datacursormode(gcf);
    set(dcm,'UpdateFcn',@fc_simesh.showmeshinfo)
  end
    %if nargout>=1, varargout{1}=ch;end
  fc_tools.graphics.RestoreHold(PrevHold)
  if nargout>=1, varargout{1}=h;end
  if nargout==2, varargout{2}=clegend;end
end